// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"gochassis/ent/chat"
	"gochassis/ent/chatroom"
	"gochassis/ent/post"
	"gochassis/ent/profile"
	"time"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// ProfileCreate is the builder for creating a Profile entity.
type ProfileCreate struct {
	config
	mutation *ProfileMutation
	hooks    []Hook
}

// SetPhoneNumber sets the "phone_number" field.
func (pc *ProfileCreate) SetPhoneNumber(s string) *ProfileCreate {
	pc.mutation.SetPhoneNumber(s)
	return pc
}

// SetNillablePhoneNumber sets the "phone_number" field if the given value is not nil.
func (pc *ProfileCreate) SetNillablePhoneNumber(s *string) *ProfileCreate {
	if s != nil {
		pc.SetPhoneNumber(*s)
	}
	return pc
}

// SetDeviceID sets the "device_id" field.
func (pc *ProfileCreate) SetDeviceID(s string) *ProfileCreate {
	pc.mutation.SetDeviceID(s)
	return pc
}

// SetDisplayname sets the "displayname" field.
func (pc *ProfileCreate) SetDisplayname(s string) *ProfileCreate {
	pc.mutation.SetDisplayname(s)
	return pc
}

// SetPassword sets the "password" field.
func (pc *ProfileCreate) SetPassword(s string) *ProfileCreate {
	pc.mutation.SetPassword(s)
	return pc
}

// SetNillablePassword sets the "password" field if the given value is not nil.
func (pc *ProfileCreate) SetNillablePassword(s *string) *ProfileCreate {
	if s != nil {
		pc.SetPassword(*s)
	}
	return pc
}

// SetBirthYear sets the "birth_year" field.
func (pc *ProfileCreate) SetBirthYear(i int16) *ProfileCreate {
	pc.mutation.SetBirthYear(i)
	return pc
}

// SetNillableBirthYear sets the "birth_year" field if the given value is not nil.
func (pc *ProfileCreate) SetNillableBirthYear(i *int16) *ProfileCreate {
	if i != nil {
		pc.SetBirthYear(*i)
	}
	return pc
}

// SetGender sets the "gender" field.
func (pc *ProfileCreate) SetGender(s string) *ProfileCreate {
	pc.mutation.SetGender(s)
	return pc
}

// SetNillableGender sets the "gender" field if the given value is not nil.
func (pc *ProfileCreate) SetNillableGender(s *string) *ProfileCreate {
	if s != nil {
		pc.SetGender(*s)
	}
	return pc
}

// SetCreatedAt sets the "created_at" field.
func (pc *ProfileCreate) SetCreatedAt(t time.Time) *ProfileCreate {
	pc.mutation.SetCreatedAt(t)
	return pc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (pc *ProfileCreate) SetNillableCreatedAt(t *time.Time) *ProfileCreate {
	if t != nil {
		pc.SetCreatedAt(*t)
	}
	return pc
}

// SetUpdatedAt sets the "updated_at" field.
func (pc *ProfileCreate) SetUpdatedAt(t time.Time) *ProfileCreate {
	pc.mutation.SetUpdatedAt(t)
	return pc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (pc *ProfileCreate) SetNillableUpdatedAt(t *time.Time) *ProfileCreate {
	if t != nil {
		pc.SetUpdatedAt(*t)
	}
	return pc
}

// SetDeletedAt sets the "deleted_at" field.
func (pc *ProfileCreate) SetDeletedAt(t time.Time) *ProfileCreate {
	pc.mutation.SetDeletedAt(t)
	return pc
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (pc *ProfileCreate) SetNillableDeletedAt(t *time.Time) *ProfileCreate {
	if t != nil {
		pc.SetDeletedAt(*t)
	}
	return pc
}

// AddChatIDs adds the "chats" edge to the Chat entity by IDs.
func (pc *ProfileCreate) AddChatIDs(ids ...int) *ProfileCreate {
	pc.mutation.AddChatIDs(ids...)
	return pc
}

// AddChats adds the "chats" edges to the Chat entity.
func (pc *ProfileCreate) AddChats(c ...*Chat) *ProfileCreate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return pc.AddChatIDs(ids...)
}

// AddChatRoomIDs adds the "chat_rooms" edge to the ChatRoom entity by IDs.
func (pc *ProfileCreate) AddChatRoomIDs(ids ...int) *ProfileCreate {
	pc.mutation.AddChatRoomIDs(ids...)
	return pc
}

// AddChatRooms adds the "chat_rooms" edges to the ChatRoom entity.
func (pc *ProfileCreate) AddChatRooms(c ...*ChatRoom) *ProfileCreate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return pc.AddChatRoomIDs(ids...)
}

// AddPostIDs adds the "posts" edge to the Post entity by IDs.
func (pc *ProfileCreate) AddPostIDs(ids ...int) *ProfileCreate {
	pc.mutation.AddPostIDs(ids...)
	return pc
}

// AddPosts adds the "posts" edges to the Post entity.
func (pc *ProfileCreate) AddPosts(p ...*Post) *ProfileCreate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pc.AddPostIDs(ids...)
}

// AddLikeIDs adds the "likes" edge to the Post entity by IDs.
func (pc *ProfileCreate) AddLikeIDs(ids ...int) *ProfileCreate {
	pc.mutation.AddLikeIDs(ids...)
	return pc
}

// AddLikes adds the "likes" edges to the Post entity.
func (pc *ProfileCreate) AddLikes(p ...*Post) *ProfileCreate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return pc.AddLikeIDs(ids...)
}

// Mutation returns the ProfileMutation object of the builder.
func (pc *ProfileCreate) Mutation() *ProfileMutation {
	return pc.mutation
}

// Save creates the Profile in the database.
func (pc *ProfileCreate) Save(ctx context.Context) (*Profile, error) {
	pc.defaults()
	return withHooks[*Profile, ProfileMutation](ctx, pc.sqlSave, pc.mutation, pc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (pc *ProfileCreate) SaveX(ctx context.Context) *Profile {
	v, err := pc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (pc *ProfileCreate) Exec(ctx context.Context) error {
	_, err := pc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (pc *ProfileCreate) ExecX(ctx context.Context) {
	if err := pc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (pc *ProfileCreate) defaults() {
	if _, ok := pc.mutation.CreatedAt(); !ok {
		v := profile.DefaultCreatedAt()
		pc.mutation.SetCreatedAt(v)
	}
	if _, ok := pc.mutation.UpdatedAt(); !ok {
		v := profile.DefaultUpdatedAt()
		pc.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (pc *ProfileCreate) check() error {
	if _, ok := pc.mutation.DeviceID(); !ok {
		return &ValidationError{Name: "device_id", err: errors.New(`ent: missing required field "Profile.device_id"`)}
	}
	if v, ok := pc.mutation.DeviceID(); ok {
		if err := profile.DeviceIDValidator(v); err != nil {
			return &ValidationError{Name: "device_id", err: fmt.Errorf(`ent: validator failed for field "Profile.device_id": %w`, err)}
		}
	}
	if _, ok := pc.mutation.Displayname(); !ok {
		return &ValidationError{Name: "displayname", err: errors.New(`ent: missing required field "Profile.displayname"`)}
	}
	if v, ok := pc.mutation.Displayname(); ok {
		if err := profile.DisplaynameValidator(v); err != nil {
			return &ValidationError{Name: "displayname", err: fmt.Errorf(`ent: validator failed for field "Profile.displayname": %w`, err)}
		}
	}
	if _, ok := pc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "Profile.created_at"`)}
	}
	if _, ok := pc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "Profile.updated_at"`)}
	}
	return nil
}

func (pc *ProfileCreate) sqlSave(ctx context.Context) (*Profile, error) {
	if err := pc.check(); err != nil {
		return nil, err
	}
	_node, _spec := pc.createSpec()
	if err := sqlgraph.CreateNode(ctx, pc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	pc.mutation.id = &_node.ID
	pc.mutation.done = true
	return _node, nil
}

func (pc *ProfileCreate) createSpec() (*Profile, *sqlgraph.CreateSpec) {
	var (
		_node = &Profile{config: pc.config}
		_spec = sqlgraph.NewCreateSpec(profile.Table, sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt))
	)
	if value, ok := pc.mutation.PhoneNumber(); ok {
		_spec.SetField(profile.FieldPhoneNumber, field.TypeString, value)
		_node.PhoneNumber = value
	}
	if value, ok := pc.mutation.DeviceID(); ok {
		_spec.SetField(profile.FieldDeviceID, field.TypeString, value)
		_node.DeviceID = value
	}
	if value, ok := pc.mutation.Displayname(); ok {
		_spec.SetField(profile.FieldDisplayname, field.TypeString, value)
		_node.Displayname = value
	}
	if value, ok := pc.mutation.Password(); ok {
		_spec.SetField(profile.FieldPassword, field.TypeString, value)
		_node.Password = value
	}
	if value, ok := pc.mutation.BirthYear(); ok {
		_spec.SetField(profile.FieldBirthYear, field.TypeInt16, value)
		_node.BirthYear = value
	}
	if value, ok := pc.mutation.Gender(); ok {
		_spec.SetField(profile.FieldGender, field.TypeString, value)
		_node.Gender = value
	}
	if value, ok := pc.mutation.CreatedAt(); ok {
		_spec.SetField(profile.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := pc.mutation.UpdatedAt(); ok {
		_spec.SetField(profile.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := pc.mutation.DeletedAt(); ok {
		_spec.SetField(profile.FieldDeletedAt, field.TypeTime, value)
		_node.DeletedAt = value
	}
	if nodes := pc.mutation.ChatsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.ChatsTable,
			Columns: []string{profile.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := pc.mutation.ChatRoomsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.ChatRoomsTable,
			Columns: profile.ChatRoomsPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := pc.mutation.PostsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   profile.PostsTable,
			Columns: []string{profile.PostsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := pc.mutation.LikesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   profile.LikesTable,
			Columns: profile.LikesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// ProfileCreateBulk is the builder for creating many Profile entities in bulk.
type ProfileCreateBulk struct {
	config
	builders []*ProfileCreate
}

// Save creates the Profile entities in the database.
func (pcb *ProfileCreateBulk) Save(ctx context.Context) ([]*Profile, error) {
	specs := make([]*sqlgraph.CreateSpec, len(pcb.builders))
	nodes := make([]*Profile, len(pcb.builders))
	mutators := make([]Mutator, len(pcb.builders))
	for i := range pcb.builders {
		func(i int, root context.Context) {
			builder := pcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*ProfileMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, pcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, pcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, pcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (pcb *ProfileCreateBulk) SaveX(ctx context.Context) []*Profile {
	v, err := pcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (pcb *ProfileCreateBulk) Exec(ctx context.Context) error {
	_, err := pcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (pcb *ProfileCreateBulk) ExecX(ctx context.Context) {
	if err := pcb.Exec(ctx); err != nil {
		panic(err)
	}
}
